#!/bin/bash

# Hiba esetén azonnal leáll a script
set -e

# Jogosultság ellenőrzés
if [ "$EUID" -ne 0 ]; then
  echo "Please, run script with sudo"
  exit 1
fi

# Kérjük be a felhasználótól a választ
echo "Válaszd ki melyik GPU-val rendelkezel:"
echo "1 - AMD - Csak ez műkszik xD"
echo "2 - NVIDIA"
read -p "Add meg a választásod (1-2): " gpu_choice

echo "Válassz ki egy kezelőfelületet:"
echo "1 - GNOME telepítés - Csak ez műkszik xD"
echo "2 - KDE telepítés"
echo "3 - XFCE telepítés"
echo "4 - Cinnamon telepítés"
read -p "Add meg a választásod (1-4): " de_choice

# Frissítsük a csomaglistát
echo "Csomaglista frissítése..."
sudo pacman -Syu --noconfirm

# Telepítsük a kívánt csomagokat
echo "Csomagok telepítése..."
# Egyebek
sudo pacman -S --noconfirm eog flatpak base-devel bash-completion firefox baobab ffmpeg git xdg-desktop-portal-wlr


# Választott GPU kódok futtatása
if [ "$gpu_choice" == "1" ]; then
  echo "AMD driverek telepítése..."
  # Itt add meg az AMD driverek telepítéséhez szükséges parancsokat
elif [ "$gpu_choice" == "2" ]; then
  echo "NVIDIA driverek telepítése..."
  # Cachykernel keyring
  sudo pacman-key --noconfirm --recv-keys F3B607488DB35A47 --keyserver keyserver.ubuntu.com
  sudo pacman-key --noconfirm --lsign-key F3B607488DB35A47

  # Cachykernel csomagok
  sudo pacman -U --noconfirm 'https://mirror.cachyos.org/repo/x86_64/cachyos/cachyos-keyring-20240331-1-any.pkg.tar.zst' \
                 'https://mirror.cachyos.org/repo/x86_64/cachyos/cachyos-mirrorlist-18-1-any.pkg.tar.zst'

  # Repo hozzáadása
  BLOCK="[cachyos]
  Include = /etc/pacman.d/cachyos-mirrorlist"

  # Ellenőrizzük, hogy a tartalom már létezik-e
  if grep -q "[cachyos]" /etc/pacman.conf; then
    echo "A [cachyos] szekció már létezik az /etc/pacman.conf fájlban."
  else
  # Hozzáfűzzük a fájlhoz a tartalmat
    echo -e "\n$BLOCK" >> /etc/pacman.conf
    echo "A [cachyos] szekció sikeresen hozzáadva az /etc/pacman.conf fájlhoz."
  fi

  # Repo update
  sudo pacman -Syu --noconfirm

  # Cachykernel telepítés
  sudo pacman -S linux-cachyos --noconfirm

  # Hozzáadás a Grub-ba
  sudo grub-mkconfig -o /boot/grub/grub.cfg --noconfirm

  # NVIDIA driver telepítő
  sudo pacman -S linux-cachyos-nvidia --noconfirm

else
  echo "Érvénytelen választás."
  exit 1
fi


# Választott DE kódok futtatása
if [ "$de_choice" == "1" ]; then
  echo "Gnome telepítése"
  echo "Alapvető csomagok"
  sudo pacman -S --noconfirm gnome-shell gdm gnome-control-center gnome-settings-daemon gnome-session

  echo "Fájlkezeő és terminál"
  sudo pacman -S --noconfirm nautilus gnome-terminal

  echo "Egyéb eszközök"
  sudo pacman -S --noconfirm gnome-tweaks gnome-shell-extensions gnome-disk-utility gnome-system-monitor gedit gnome-calculator gnome-browser-connector

  # GDM engedélyezése
  echo "Enabling GDM service..."
  systemctl enable gdm.service


elif [ "$de_choice" == "2" ]; then
  # Itt add meg a szükséges parancsokat

elif [ "$de_choice" == "3" ]; then
  # Itt add meg a szükséges parancsokat

elif [ "$de_choice" == "4" ]; then
  # Itt add meg a szükséges parancsokat

else
  echo "Érvénytelen választás."
  exit 1
fi

# Restart
echo "Újraindítás..."
for ((i=5; i>0; i--)); do
  echo "$i"
  sleep 1
done

reboot
  
